: Class Billboard

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.media.j3d
Class Billboard

    java.lang.Object
      |
      +--javax.media.j3d.SceneGraphObject
            |
            +--javax.media.j3d.Node
                  |
                  +--javax.media.j3d.Leaf
                        |
                        +--javax.media.j3d.Behavior
                              |
                              +--javax.media.j3d.Billboard

public class Billboard
extends Behavior

The Billboard behavior node operates on the TransformGroup node to cause the local +z axis of the TransformGroup to point at the viewer's eye position. This is done regardless of the transforms above the specified TransformGroup node in the scene graph.

If the alignment mode is ROTATE_AXIS, then the rotation will be around the specified axis. If the alignment mode is ROTATE_ABOUT_POINT, then the rotation will be about the specfied point, with an additional rotation to align the +y axis of the TransformGroup with the +y axis in the View.

Billboard nodes provide the most benefit for complex, roughly-symmetric objects. A typical use might consist of a quadrilateral that contains a texture of a tree.

Field Summary
`static int` | `ROTATE_ABOUT_AXIS` Specifies that rotation should be about the specified axis.
`static int` | `ROTATE_ABOUT_POINT` Specifies that rotation should be about the specified point and that the children's Y-axis should match the view object's Y-axis.

Fields inherited from class javax.media.j3d.Node
`ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_PICK, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

Constructor Summary
`Billboard()` Constructs a Billboard node with default parameters.
`Billboard(TransformGroup tg)` Constructs a Billboard node with default parameters that operates on the specified TransformGroup node.
`Billboard(TransformGroup tg, int mode, Point3f point)` Constructs a Billboard node with the specified rotation point and mode that operates on the specified TransformGroup node.
`Billboard(TransformGroup tg, int mode, Vector3f axis)` Constructs a Billboard node with the specified axis and mode that operates on the specified TransformGroup node.

Method Summary
`Node` | `cloneNode(boolean forceDuplicate)` Creates a new instance of the node.
`void` | `duplicateNode(Node originalNode, boolean forceDuplicate)` Copies all node information from `originalNode` into the current node.
`void` | `getAlignmentAxis(Vector3f axis)` Gets the alignment axis and sets the parameter to this value
`int` | `getAlignmentMode()` Gets the alignment mode.
`void` | `getRotationPoint(Point3f point)` Gets the rotation point and sets the parameter to this value
`TransformGroup` | `getTarget()` Returns a copy of the transformGroup associated with this BillBoard;
`void` | `initialize()` Initialize method that sets up initial wakeup criteria.
`void` | `processStimulus(java.util.Enumeration criteria)` Process stimulus method that computes appropriate transform.
`void` | `setAlignmentAxis(float x, float y, float z)` Sets the alignment axis.
`void` | `setAlignmentAxis(Vector3f axis)` Sets the alignment axis.
`void` | `setAlignmentMode(int mode)` Sets the alignment mode.
`void` | `setRotationPoint(float x, float y, float z)` Sets the rotate point.
`void` | `setRotationPoint(Point3f point)` Sets the rotation point.
`void` | `setTarget(TransformGroup tg)` Sets the tranformGroup for this Billboard object.
`void` | `updateNodeReferences(NodeReferenceTable referenceTable)` Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`.

Methods inherited from class javax.media.j3d.Behavior
`getEnable, getSchedulingBoundingLeaf, getSchedulingBounds, getView, postId, setEnable, setSchedulingBoundingLeaf, setSchedulingBounds, wakeupOn`

Methods inherited from class javax.media.j3d.Node
`cloneTree, cloneTree, cloneTree, getBounds, getBoundsAutoCompute, getCollidable, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

Methods inherited from class javax.media.j3d.SceneGraphObject
`clearCapability, duplicateSceneGraphObject, getCapability, getUserData, isCompiled, isLive, setCapability, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ROTATE_ABOUT_AXIS

    public static final int ROTATE_ABOUT_AXIS

  Specifies that rotation should be about the specified axis.

### ROTATE_ABOUT_POINT

    public static final int ROTATE_ABOUT_POINT

  Specifies that rotation should be about the specified point and that the children's Y-axis should match the view object's Y-axis.

Constructor Detail

### Billboard

    public Billboard()

  Constructs a Billboard node with default parameters. The default values are as follows:
  alignment mode : ROTATE_ABOUT_AXIS
  alignment axis : Y-axis (0,1,0)
  rotation point : (0,0,1)
  target transform group: null

### Billboard

    public Billboard(TransformGroup tg)

  Constructs a Billboard node with default parameters that operates on the specified TransformGroup node. The default alignment mode is ROTATE_ABOUT_AXIS rotation with the axis pointing along the Y axis.
  Parameters:
    `tg` - the TransformGroup node that this Billboard node operates upon

### Billboard

    public Billboard(TransformGroup tg,
                     int mode,
                     Vector3f axis)

  Constructs a Billboard node with the specified axis and mode that operates on the specified TransformGroup node.
  Parameters:
    `tg` - the TransformGroup node that this Billboard node operates upon
    `mode` - alignment mode, one of ROTATE_AXIS or ROTATE_ABOUT_POINT
    `axis` - the ray about which the billboard rotates

### Billboard

    public Billboard(TransformGroup tg,
                     int mode,
                     Point3f point)

  Constructs a Billboard node with the specified rotation point and mode that operates on the specified TransformGroup node.
  Parameters:
    `tg` - the TransformGroup node that this Billboard node operates upon
    `mode` - alignment mode, one of ROTATE_AXIS or ROTATE_ABOUT_POINT
    `point` - the position about which the billboard rotates

Method Detail

### setAlignmentMode

    public final void setAlignmentMode(int mode)

  Sets the alignment mode.
  Parameters:
    `mode` - one of: ROTATE_ABOUT_AXIS or ROTATE_ABOUT_POINT

### getAlignmentMode

    public final int getAlignmentMode()

  Gets the alignment mode.
  Returns:
    one of: ROTATE_ABOUT_AXIS or ROTATE_ABOUT_POINT

### setAlignmentAxis

    public final void setAlignmentAxis(Vector3f axis)

  Sets the alignment axis.
  Parameters:
    `axis` - the ray about which the billboard rotates

### setAlignmentAxis

    public final void setAlignmentAxis(float x,
                                       float y,
                                       float z)

  Sets the alignment axis.
  Parameters:
    `x` - the x component of the ray about which the billboard rotates
    `y` - the y component of the ray about which the billboard rotates
    `z` - the z component of the ray about which the billboard rotates

### getAlignmentAxis

    public final void getAlignmentAxis(Vector3f axis)

  Gets the alignment axis and sets the parameter to this value
  Parameters:
    `axis` - the vector that will contain the ray about which the billboard rotates

### setRotationPoint

    public final void setRotationPoint(Point3f point)

  Sets the rotation point.
  Parameters:
    `point` - the point about which the billboard rotates

### setRotationPoint

    public final void setRotationPoint(float x,
                                       float y,
                                       float z)

  Sets the rotate point.
  Parameters:
    `x` - the x component of the point about which the billboard rotates
    `y` - the y component of the point about which the billboard rotates
    `z` - the z component of the point about which the billboard rotates

### getRotationPoint

    public final void getRotationPoint(Point3f point)

  Gets the rotation point and sets the parameter to this value
  Parameters:
    `point` - the position that the Billboard rotates about

### setTarget

    public final void setTarget(TransformGroup tg)

  Sets the tranformGroup for this Billboard object.
  Parameters:
    `tg` - the transformGroup node which replaces the current transformGroup node for this Billboard

### getTarget

    public final TransformGroup getTarget()

  Returns a copy of the transformGroup associated with this BillBoard;
  Returns:
    the TranformGroup for this Billboard

### initialize

    public void initialize()

  Initialize method that sets up initial wakeup criteria.
  Overrides:
    initialize in class Behavior

### processStimulus

    public void processStimulus(java.util.Enumeration criteria)

  Process stimulus method that computes appropriate transform.
  Overrides:
    processStimulus in class Behavior
  Parameters:
    `criteria` - an enumeration of the criteria that caused the stimulus

### cloneNode

    public Node cloneNode(boolean forceDuplicate)

  Creates a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.
  Overrides:
    cloneNode in class Node
  Parameters:
    `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
  See Also:
    `Node.cloneTree()`, `Node.cloneNode(boolean)`, `Node.duplicateNode(javax.media.j3d.Node, boolean)`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

### duplicateNode

    public void duplicateNode(Node originalNode,
                              boolean forceDuplicate)

  Copies all node information from `originalNode` into the current node. This method is called from the `cloneNode` method which is, in turn, called by the `cloneTree` method.

  For any NodeComponent objects contained by the object being duplicated, each NodeComponent object's `duplicateOnCloneTree` value is used to determine whether the NodeComponent should be duplicated in the new node or if just a reference to the current node should be placed in the new node. This flag can be overridden by setting the `forceDuplicate` parameter in the `cloneTree` method to `true`.

  Overrides:
    duplicateNode in class Behavior
  Parameters:
    `originalNode` - the original node to duplicate.
    `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
  See Also:
    `Group.cloneNode(boolean)`, `Node.duplicateNode(javax.media.j3d.Node, boolean)`, `Node.cloneTree()`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

### updateNodeReferences

    public void updateNodeReferences(NodeReferenceTable referenceTable)

  Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`. This method is called by `cloneTree` after all nodes in the sub-graph have been duplicated. The cloned Leaf node's method will be called and the Leaf node can then look up any object references by using the `getNewObjectReference` method found in the `NodeReferenceTable` object. If a match is found, a reference to the corresponding object in the newly cloned sub-graph is returned. If no corresponding reference is found, either a DanglingReferenceException is thrown or a reference to the original object is returned depending on the value of the `allowDanglingReferences` parameter passed in the `cloneTree` call.
  Overrides:
    updateNodeReferences in class Behavior
  Parameters:
    `referenceTable` - a NodeReferenceTableObject that contains the `getNewObjectReference` method needed to search for new object instances.
  See Also:
    `NodeReferenceTable`, `Node.cloneTree()`, `DanglingReferenceException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD